import java.io.*;
import java.net.*;
import java.awt.*;
import CryptConnection;

public class LoadTest extends java.applet.Applet
{
	public boolean mouseDown(Event evt, int x, int y)
	{
	System.out.println("Test 1");
	try {
		URL u = new URL("http://wyvern/jcameron/raserver1.pdf");
		LineInputStream is = new LineInputStream(u.openStream());
		byte b[] = new byte[186751];
		System.out.println("Before reading..");
		int r = is.read(b);
		System.out.println("Read "+r+" bytes");
		}
	catch(Exception e)
		System.out.println("Error : "+e.getMessage());


	System.out.println("Test 2");
	try {
		URL u = new URL("http://wyvern/jcameron/raserver1.pdf");
		LineInputStream is = new LineInputStream(u.openStream());
		byte b[] = new byte[186751];
		System.out.println("Before reading..");
		int p = 0;
		do {
			int r = is.read(b, p, is.available());
			if (r >= 0)
				System.out.println("Up to "+(p+=r));
			else
				System.out.println("Hit EOF");
			Thread.sleep(100);
			} while(p < b.length);
		System.out.println("Done!");
		}
	catch(Exception e)
		System.out.println("Error : "+e.getMessage());

	System.out.println("Test 3");
	try {
		Socket s = new Socket("wyvern",19);
		CryptConnection con = new CryptConnection(s.getInputStream(),
							  s.getOutputStream());
		CryptInputStream is = con.getInputStream();
		byte b[] = new byte[100000];
		System.out.println("Before reading..");
		int p = 0;
		do {
			int r = is.read(b, p, b.length-p);
			if (r >= 0)
				System.out.println("Up to "+(p+=r));
			else
				System.out.println("Hit EOF");
			Thread.sleep(100);
			} while(p < b.length);
		System.out.println("Done!");
		}
	catch(Exception e)
		System.out.println("Error : "+e.getMessage());

	System.out.println("Test 4");
	try {
		Socket s = new Socket("wyvern",9888);
		CryptConnection con = new CryptConnection(s.getInputStream(),
							  s.getOutputStream());
		CryptInputStream is = con.getInputStream();
		CryptOutputStream os = con.getOutputStream();

		Message au = new Message();
		au.add("Request","Auth");
		au.add("Username","jcameron");
		au.add("Password","bar");
		au.send(os);
		new Message();

		Message gt = new Message();
		gt.add("Request","Get");
		gt.add("File","/stuff/goofey.c");
		gt.send(os);

		System.out.println("Before reading..");
		byte b[] = new byte[32440];
		int p = 0;
		do {
			int r = is.read(b, p, b.length-p);
			if (r >= 0)
				System.out.println("Up to "+(p+=r));
			else
				System.out.println("Hit EOF");
			Thread.sleep(100);
			} while(p < b.length);
		System.out.println("Done!");
		}
	catch(Exception e)
		System.out.println("Error : "+e.getMessage());

	return true;
	}

	public void paint(Graphics g)
	{
	g.setColor(Color.red);
	g.fillRect(0, 0, size().width, size().height);
	}
}
